JUCE: OggVorbisAudioFormat Class Reference

JUCE

Public Member Functions | Static Public Attributes | List of all members
OggVorbisAudioFormat Class Reference

Reads and writes the Ogg-Vorbis audio format. More...

Inheritance diagram for OggVorbisAudioFormat:

## Public Member Functions
| OggVorbisAudioFormat ()
| ~OggVorbisAudioFormat () override
Array< int > | getPossibleSampleRates () override
| Returns a set of sample rates that the format can read and write. More...
Array< int > | getPossibleBitDepths () override
| Returns a set of bit depths that the format can read and write. More...
bool | canDoStereo () override
| Returns true if the format can do 2-channel audio. More...
bool | canDoMono () override
| Returns true if the format can do 1-channel audio. More...
bool | isCompressed () override
| Returns true if the format uses compressed data. More...
StringArray | getQualityOptions () override
| Returns a list of different qualities that can be used when writing. More...
int | estimateOggFileQuality (const File &source)
| Tries to estimate the quality level of an ogg file based on its size. More...
AudioFormatReader * | createReaderFor (InputStream *sourceStream, bool deleteStreamIfOpeningFails) override
| Tries to create an object that can read from a stream containing audio data in this format. More...
AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, unsigned int numberOfChannels, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex) override
| Tries to create an object that can write to a stream with this audio format. More...
virtual AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, unsigned int numberOfChannels, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)=0
| Tries to create an object that can write to a stream with this audio format. More...
virtual AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, const AudioChannelSet &channelLayout, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)
| Tries to create an object that can write to a stream with this audio format. More...
Public Member Functions inherited from AudioFormat
virtual | ~AudioFormat ()
| Destructor. More...
const String & | getFormatName () const
| Returns the name of this format. More...
virtual StringArray | getFileExtensions () const
| Returns all the file extensions that might apply to a file of this format. More...
virtual bool | canHandleFile (const File &fileToTest)
| Returns true if this the given file can be read by this format. More...
virtual bool | isChannelLayoutSupported (const AudioChannelSet &channelSet)
| Returns true if the channel layout is supported by this format. More...
virtual MemoryMappedAudioFormatReader * | createMemoryMappedReader (const File &file)
| Attempts to create a MemoryMappedAudioFormatReader, if possible for this format. More...
virtual MemoryMappedAudioFormatReader * | createMemoryMappedReader (FileInputStream *fin)
virtual AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, const AudioChannelSet &channelLayout, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)
| Tries to create an object that can write to a stream with this audio format. More...

## Static Public Attributes
static const char *const | encoderName
| Metadata property name used by the Ogg writer - if you set a string for this value, it will be written into the ogg file as the name of the encoder app. More...
static const char *const | id3title
| Metadata key for setting an ID3 title. More...
static const char *const | id3artist
| Metadata key for setting an ID3 artist name. More...
static const char *const | id3album
| Metadata key for setting an ID3 album. More...
static const char *const | id3comment
| Metadata key for setting an ID3 comment. More...
static const char *const | id3date
| Metadata key for setting an ID3 date. More...
static const char *const | id3genre
| Metadata key for setting an ID3 genre. More...
static const char *const | id3trackNumber
| Metadata key for setting an ID3 track number. More...

## Additional Inherited Members
Protected Member Functions inherited from AudioFormat
| AudioFormat (String formatName, StringArray fileExtensions)
| Creates an AudioFormat object. More...
| AudioFormat (StringRef formatName, StringRef fileExtensions)
| Creates an AudioFormat object. More...

## Detailed Description

Reads and writes the Ogg-Vorbis audio format.

To compile this, you'll need to set the JUCE_USE_OGGVORBIS flag.

See also
  AudioFormat,

## Constructor & Destructor Documentation

## ◆ OggVorbisAudioFormat()

OggVorbisAudioFormat::OggVorbisAudioFormat | ( |  | ) |

## ◆ ~OggVorbisAudioFormat()

OggVorbisAudioFormat::~OggVorbisAudioFormat | ( |  | ) |
| override

## Member Function Documentation

## ◆ getPossibleSampleRates()

Array<int> OggVorbisAudioFormat::getPossibleSampleRates | ( |  | ) |
| overridevirtual

Returns a set of sample rates that the format can read and write.

Implements AudioFormat.

## ◆ getPossibleBitDepths()

Array<int> OggVorbisAudioFormat::getPossibleBitDepths | ( |  | ) |
| overridevirtual

Returns a set of bit depths that the format can read and write.

Implements AudioFormat.

## ◆ canDoStereo()

bool OggVorbisAudioFormat::canDoStereo | ( |  | ) |
| overridevirtual

Returns true if the format can do 2-channel audio.

Implements AudioFormat.

## ◆ canDoMono()

bool OggVorbisAudioFormat::canDoMono | ( |  | ) |
| overridevirtual

Returns true if the format can do 1-channel audio.

Implements AudioFormat.

## ◆ isCompressed()

bool OggVorbisAudioFormat::isCompressed | ( |  | ) |
| overridevirtual

Returns true if the format uses compressed data.

Reimplemented from AudioFormat.

## ◆ getQualityOptions()

StringArray OggVorbisAudioFormat::getQualityOptions | ( |  | ) |
| overridevirtual

Returns a list of different qualities that can be used when writing.

Non-compressed formats will just return an empty array, but for something like Ogg-Vorbis or MP3, it might return a list of bit-rates, etc.

When calling createWriterFor(), an index from this array is passed in to tell the format which option is required.

Reimplemented from AudioFormat.

## ◆ estimateOggFileQuality()

int OggVorbisAudioFormat::estimateOggFileQuality | ( | const File & | source | ) |

Tries to estimate the quality level of an ogg file based on its size.

If it can't read the file for some reason, this will just return 1 (medium quality), otherwise it will return the approximate quality setting that would have been used to create the file.

See also
  getQualityOptions

## ◆ createReaderFor()

AudioFormatReader* OggVorbisAudioFormat::createReaderFor | ( | InputStream * | sourceStream,
|  | bool | deleteStreamIfOpeningFails
| ) |  |
| overridevirtual

Tries to create an object that can read from a stream containing audio data in this format.

The reader object that is returned can be used to read from the stream, and should then be deleted by the caller.

Parameters

  sourceStream | the stream to read from - the AudioFormatReader object that is returned will delete this stream when it no longer needs it.
  deleteStreamIfOpeningFails | if no reader can be created, this determines whether this method should delete the stream object that was passed-in. (If a valid reader is returned, it will always be in charge of deleting the stream, so this parameter is ignored)

See also
  AudioFormatReader

Implements AudioFormat.

## ◆ createWriterFor() [1/3]

AudioFormatWriter* OggVorbisAudioFormat::createWriterFor | ( | OutputStream * | streamToWriteTo,
|  | double | sampleRateToUse,
|  | unsigned int | numberOfChannels,
|  | int | bitsPerSample,
|  | const StringPairArray & | metadataValues,
|  | int | qualityOptionIndex
| ) |  |
| overridevirtual

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  numberOfChannels | the number of channels
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

Implements AudioFormat.

## ◆ createWriterFor() [2/3]

virtual AudioFormatWriter* AudioFormat::createWriterFor

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  numberOfChannels | the number of channels
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

## ◆ createWriterFor() [3/3]

virtual AudioFormatWriter* AudioFormat::createWriterFor

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  channelLayout | the channel layout for the file. Use isChannelLayoutSupported to check if the writer supports this layout.
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

## Member Data Documentation

## ◆ encoderName

const char* const OggVorbisAudioFormat::encoderName
| static

Metadata property name used by the Ogg writer - if you set a string for this value, it will be written into the ogg file as the name of the encoder app.

See also
  createWriterFor

## ◆ id3title

const char* const OggVorbisAudioFormat::id3title
| static

Metadata key for setting an ID3 title.

## ◆ id3artist

const char* const OggVorbisAudioFormat::id3artist
| static

Metadata key for setting an ID3 artist name.

## ◆ id3album

const char* const OggVorbisAudioFormat::id3album
| static

Metadata key for setting an ID3 album.

## ◆ id3comment

const char* const OggVorbisAudioFormat::id3comment
| static

Metadata key for setting an ID3 comment.

## ◆ id3date

const char* const OggVorbisAudioFormat::id3date
| static

Metadata key for setting an ID3 date.

## ◆ id3genre

const char* const OggVorbisAudioFormat::id3genre
| static

Metadata key for setting an ID3 genre.

## ◆ id3trackNumber

const char* const OggVorbisAudioFormat::id3trackNumber
| static

Metadata key for setting an ID3 track number.

The documentation for this class was generated from the following file:

- juce_OggVorbisAudioFormat.h